﻿using Microsoft.Office.Interop.Outlook;
using System;
using System.Drawing;

namespace TestProject
{
    /// <summary>
    /// 커스텀 애드인
    /// </summary>
    public partial class CustomAddIn
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 애플리케이션
        /// </summary>
        private Application application = null;

        /// <summary>
        /// 타겟 폴더
        /// </summary>
        private Folder targetFolder = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 커스텀 애드인 시작시 처리하기 - CustomAddIn_Startup(sender, e)

        /// <summary>
        /// 커스텀 애드인 시작시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void CustomAddIn_Startup(object sender, EventArgs e)
        {
            this.application = Application;

            // Outlook에서 계정 폴더 아래에 Parent\Child 폴더가 사전에 생성되어 있어야 한다.
            Folder parentFolder = this.application.ActiveExplorer().Session.Folders[1].Folders["Parent"] as Folder;
            
            this.targetFolder = parentFolder.Folders["Child"] as Folder;

            SetCustomIcon(this.targetFolder);
        }

        #endregion
        #region 커스텀 애드인 셧다운시 처리하기 - CustomAddIn_Shutdown(sender, e)

        /// <summary>
        /// 커스텀 애드인 셧다운시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void CustomAddIn_Shutdown(object sender, EventArgs e)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region VSTO에서 생성한 코드

        /// <summary>
        /// 디자이너 지원에 필요한 메서드입니다. 
        /// 이 메서드의 내용을 코드 편집기로 수정하지 마세요.
        /// </summary>
        private void InternalStartup()
        {
            this.Startup  += new System.EventHandler(CustomAddIn_Startup );
            this.Shutdown += new System.EventHandler(CustomAddIn_Shutdown);
        }

        #endregion

        #region 커스텀 아이콘 설정하기 - SetCustomIcon(folder)

        /// <summary>
        /// 커스텀 아이콘 설정하기
        /// </summary>
        /// <param name="folder">폴더</param>
        private void SetCustomIcon(MAPIFolder folder)
        {
            Bitmap bitmap = null;

            try
            {
                bitmap = Properties.Resources.sample;

                stdole.StdPicture picture = PictureConverter.ToPicture(bitmap) as stdole.StdPicture;

                folder.SetCustomIcon(picture);
            }
            finally
            {
                bitmap.Dispose();
            }
        }

        #endregion
    }
}